package nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.generator;

import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.type.TypeFactory;
import io.quarkus.gizmo.Gizmo;
import lombok.Getter;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.ClientMethodDefinition;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.util.ApprovalTestsClassDisplayer;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.util.JavaTypeDataFaker;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.util.RecordingSignalRSession;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.util.RecordingSignalRSession.RecordedInvocation;
import nl.rug.digitallab.quarkus.signalr.extension.runtime.connector.SignalRConnector;
import nl.rug.digitallab.quarkus.signalr.extension.runtime.session.SignalRSession;
import org.approvaltests.Approvals;
import org.approvaltests.core.Options;
import org.junit.jupiter.api.*;
import org.objectweb.asm.*;

import java.io.IOException;
import java.lang.reflect.Array;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import static org.junit.jupiter.api.Assertions.*;

public abstract class GenericGeneratorTest<T extends ClientMethodGenerator> {

    private T clientMethodGenerator;

    /**
     * This method will generate the implicit default no-argument constructor for the class
     *
     * @param writer       - The class writer
     * @param internalName - The internal name of the class
     */
    private static void generateConstructor(ClassWriter writer, String internalName) {
        writer.visit(
                Opcodes.V1_8, Opcodes.ACC_PUBLIC, internalName, null, "java/lang/Object", new String[0]
        );

        // Synthesize the constructor for the class. This is a default constructor
        // Turns out the default constructor is not, in fact, implicit, it's just generated by the compiler
        MethodVisitor constructor = writer.visitMethod(
                Opcodes.ACC_PUBLIC, "<init>", "()V", null, null
        );
        constructor.visitVarInsn(Opcodes.ALOAD, 0);
        constructor.visitMethodInsn(
                Opcodes.INVOKESPECIAL, "java/lang/Object", "<init>", "()V", false
        );
        constructor.visitInsn(Opcodes.RETURN);

        // Since COMPUTE_MAXS is enabled, 0,0 is fine
        constructor.visitMaxs(0, 0);
        constructor.visitEnd();
    }

    public abstract Type getHandledType();

    public abstract T createClientMethodGenerator();

    public abstract Object getMethodContainer();

    public abstract Object unwrapMethodInvocationResult(Object result);

    public abstract boolean expectsStreamable();

    @BeforeEach
    public void setUp() {
        clientMethodGenerator = createClientMethodGenerator();
    }

    @Test
    @DisplayName("Test if the generator can handle the correct type")
    public void testCanHandleType() {
        assertTrue(clientMethodGenerator.canHandle(getHandledType()));
    }

    @Test
    @DisplayName("Approval test for the generated bytecode")
    public void approvalTestBytecode() throws IOException {
        byte[] mutatedBytecode = generateClassWithIsolatedBytecode();
        String displayedBytecode = ApprovalTestsClassDisplayer.displayClass(mutatedBytecode);

        // Dump the bytecode into approval testing
        Approvals.verify(displayedBytecode, new Options().forFile().withExtension(
                clientMethodGenerator.getClass().getSimpleName() + ".asm.txt"
        ));
    }

    @TestFactory
    @DisplayName("Generated bytecode tests")
    public List<DynamicTest> testGenerateClientMethodBytecode() throws IOException, ReflectiveOperationException {
        // Obtain bytecode of mutated class
        byte[] mutatedBytecode = generateClassWithIsolatedBytecode();
        String internalName = "nl.rug.digitallab.quarkus.signalr.extension.deployment.helper.asm.generator.GeneratedClass"
                + clientMethodGenerator.getClass().getSimpleName();

        // Load the class in a custom class loader
        ClassLoader classLoader = new ClassLoader(GenericGeneratorTest.class.getClassLoader()) {
            @Override
            protected Class<?> findClass(String name) throws ClassNotFoundException {
                if (name.equals(internalName)) {
                    return defineClass(name, mutatedBytecode, 0, mutatedBytecode.length);
                }
                return super.findClass(name);
            }
        };

        // Create an instance of the class
        Class<?> remappedClass = Class.forName(internalName, true, classLoader);
        Object instance = remappedClass.getDeclaredConstructor().newInstance();

        List<DynamicTest> tests = new ArrayList<>();

        for (Method method : remappedClass.getDeclaredMethods()) {
            // Make sure first arg is SignalRSession
            if (method.getParameters().length == 0)
                continue;

            if (!method.getParameters()[0].getType().equals(SignalRSession.class))
                continue;

            String testName = "Test method " + method.getName()
                    + " for generator " + this.clientMethodGenerator.getClass().getSimpleName();

            tests.add(DynamicTest.dynamicTest(testName, () -> runTestForMethod(method, instance)));
        }

        return tests;
    }

    /**
     * This method will run a test for a specific method. It will generate the arguments for the method invocation,
     * invoke the method, and assert that the invocation was recorded correctly.
     *
     * @param method   - The method that will be invoked
     * @param instance - The instance of the class that contains the method
     * @throws IllegalAccessException    - If the method cannot be accessed
     * @throws InvocationTargetException - If the method invocation fails
     */
    private void runTestForMethod(Method method, Object instance) throws IllegalAccessException, InvocationTargetException {
        Object[] arguments = generateArgumentsForInvocation(method);
        Object result = method.invoke(instance, arguments);
        RecordingSignalRSession session = (RecordingSignalRSession) arguments[0];

        assertTrue(session.isMethodInvoked(method.getName()));

        RecordedInvocation invocation = session.getInvocations().stream()
                .filter(i -> i.getMethodName().equals(method.getName()))
                .findFirst()
                .orElseThrow(() -> new AssertionError("Method not invoked"));

        assertRecordedInvocation(method, invocation, result, arguments);
    }

    /**
     * This method will generate the arguments for the method invocation. It will generate a SignalRSession as the first
     * argument, and fake data for the rest of the arguments. The fake data will be generated based on the required type
     * of the argument.
     * <p>
     * The first argument is guaranteed to be a RecordingSignalRSession, as it is required for the client method generator
     * to work.
     *
     * @param method - The method that will be invoked
     * @return - An array of arguments that can be used to invoke the method
     */
    private Object[] generateArgumentsForInvocation(Method method) {
        Object[] arguments = new Object[method.getParameterCount()];
        arguments[0] = new RecordingSignalRSession(UUID.randomUUID(), UUID.randomUUID(),
                new SignalRConnector(null, null, null), new ObjectMapper(), 1);

        for (int i = 1; i < arguments.length; i++) {
            // Obtain the correct JavaType for the argument
            JavaType requiredType = TypeFactory.defaultInstance().constructType(method.getParameters()[i].getParameterizedType());
            arguments[i] = JavaTypeDataFaker.generateFakeData(requiredType);
        }

        return arguments;
    }

    /**
     * This method will assert that the recorded invocation is correct. It will check if the method name is correct,
     * if the arguments are correct, and if the result is correct. It will also check if the method is streamable or not.
     *
     * @param method     - The method that was invoked
     * @param invocation - The recorded invocation
     * @param result     - The result of the method invocation
     * @param arguments  - The arguments of the method invocation
     */
    private void assertRecordedInvocation(Method method, RecordedInvocation invocation, Object result, Object[] arguments) {
        // Make sure streamable is correct
        assertEquals(expectsStreamable(), invocation.isStreamable());

        // Unwrap the result
        Object unwrappedResult = unwrapMethodInvocationResult(result);
        if (unwrappedResult == null) {
            // If the unwrappedResult is null, we're dealing with a Void method
            // therefore, the return type should also be null.
            assertNull(invocation.getReturnType());
        } else {
            assertMatchesFakeData(unwrappedResult, invocation.getReturnType());
        }

        // Make sure the method name is correct
        assertEquals(invocation.getMethodName(), method.getName());

        // Check if the arguments are correct
        assertEquals(invocation.getParams().length, arguments.length - 1);
        for (int i = 0; i < invocation.getParams().length; i++) {
            JavaType requiredType = TypeFactory.defaultInstance().constructType(method.getParameters()[i + 1].getParameterizedType());
            assertMatchesFakeData(arguments[i + 1], requiredType);
        }
    }

    /**
     * This method will assert that the result matches the fake data generated for the required type.
     * If the result is an array, it will check each element individually. (since arrays are not equal by reference,
     * and JUnit assertEqualsArray breaks on implicit primitive casts)
     *
     * @param result       - The result of the method invocation
     * @param requiredType - The required type of the result
     */
    private void assertMatchesFakeData(Object result, JavaType requiredType) {
        Object fakeData = JavaTypeDataFaker.generateFakeData(requiredType);

        if (result.getClass().isArray()) {
            int resultLength = Array.getLength(result);
            int fakeDataLength = Array.getLength(fakeData);

            assertEquals(resultLength, fakeDataLength);
            for (int i = 0; i < resultLength; i++) {
                assertEquals(Array.get(result, i), Array.get(fakeData, i));
            }
        } else {
            assertEquals(result, fakeData);
        }
    }

    /**
     * This method will synthesize the bytecode for a fictitious SignalRHub class by running the client method generator
     * on each method in the method container class. The generated bytecode will map to a class that has the same methods,
     * however, it will not respect all the constraints of a usual SignalRHub class. It will only provide the bare minimum
     * to test the client method generator. The original method container will not be modified.
     *
     * @return - The bytecode of the synthesized class
     * @throws IOException - If the class cannot be synthesized
     */
    private byte[] generateClassWithIsolatedBytecode() throws IOException {
        Object container = getMethodContainer();

        // Get all the methods inside the class itself. This cannot be done using reflection,
        // as we need generic information
        ClassReader reader = new ClassReader(container.getClass().getName());
        ClassMethodEnumerator enumerator = new ClassMethodEnumerator();
        reader.accept(enumerator, ClassReader.SKIP_CODE);
        List<ClientMethodDefinition> definitions = enumerator.getDefinitions();

        // Synthesize a class with a method that will be filled out by the generator
        String internalName = "nl/rug/digitallab/quarkus/signalr/extension/deployment/helper/asm/generator/GeneratedClass"
                + clientMethodGenerator.getClass().getSimpleName();
        ClassWriter writer = new ClassWriter(ClassWriter.COMPUTE_FRAMES | ClassWriter.COMPUTE_MAXS);
        generateConstructor(writer, internalName);

        // This will generate a method for each method in the container
        for (ClientMethodDefinition definition : definitions) {
            MethodVisitor mv = writer.visitMethod(
                    Opcodes.ACC_PUBLIC, // Synthetic methods are public
                    definition.getName(),
                    definition.getDescriptor(),
                    definition.getSignature(),
                    definition.getExceptions()
            );

            Type[] argumentTypes = Type.getArgumentTypes(definition.getDescriptor());

            // Remove the session argument
            Type[] arguments = new Type[argumentTypes.length - 1];
            System.arraycopy(argumentTypes, 1, arguments, 0, arguments.length);

            // Force the client method generator to generate the method
            clientMethodGenerator.generateClientMethodBytecode(definition, mv, arguments);

            mv.visitEnd();
        }

        writer.visitEnd();

        return writer.toByteArray();
    }

    /**
     * This class will enumerate all the methods in a class and store them in a list
     * for later processing. It will get <u>all</u> methods in a class, including private,
     * protected, static, etc. The only methods it will skip are constructors. (which internally,
     * are still just methods)
     */
    @Getter
    private static class ClassMethodEnumerator extends ClassVisitor {
        private final List<ClientMethodDefinition> definitions = new ArrayList<>();

        public ClassMethodEnumerator() {
            super(Gizmo.ASM_API_VERSION);
        }

        @Override
        public MethodVisitor visitMethod(int access, String name, String descriptor, String signature, String[] exceptions) {
            // Skip constructors
            if (name.equals("<init>")) {
                return null;
            }

            definitions.add(new ClientMethodDefinition(access, name, descriptor, signature, exceptions, List.of()));
            return null;
        }
    }
}
